package core.engine.terrain;

import core.engine.Loader;
import core.engine.model.RawModel;
import core.engine.model.TexturedModel;
import core.engine.textures.ModelTexture;
import utils.vectors.Vector3f;

import java.util.Objects;

public class TerrainTile {

    private RawModel model;
    private final Vector3f position;
    private final float rotX, rotY, rotZ;
    private final float scale;
    private Vector3f color = new Vector3f();

    public TerrainTile(RawModel model, Vector3f position, float rotX, float rotY, float rotZ, float scale) {
        this.model = model;
        this.position = position;
        this.rotX = rotX;
        this.rotY = rotY;
        this.rotZ = rotZ;
        this.scale = scale;
    }

    public void setColor(Vector3f color) {
        this.color = color;
    }

    public RawModel getModel() {
        return model;
    }

    public Vector3f getPosition() {
        return position;
    }

    public float getRotX() {
        return rotX;
    }

    public float getRotY() {
        return rotY;
    }

    public float getRotZ() {
        return rotZ;
    }

    public float getScale() {
        return scale;
    }

    public Vector3f getColor() {
        return color;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TerrainTile that = (TerrainTile) o;
        return Objects.equals(model, that.model) && Objects.equals(position, that.position);
    }

    @Override
    public int hashCode() {
        return Objects.hash(model, position);
    }
}